unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TLinePattern = array[0..11] of Byte;
  PLinePattern = ^TLinePattern;

  TDDAData = record
    Canvas: TCanvas;
    Pos: Integer;
    Pattern: PLinePattern;
  end;
  PDDAData = ^TDDAData;

  TForm1 = class(TForm)
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  procedure LineDDAProc(X, Y: Integer; Data: LongInt); stdcall;

var
  Drawing: Boolean;
  FirstPoint: TPoint;
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
  LP: TLinePattern = (1, 1, 1,
                      0, 0, 0,
                      1, 1, 1,
                      0, 0, 0);
var
  i: Integer;
  Data: TDDAData;
begin
  if Drawing then
  begin
    Data.Canvas := Canvas;
    Data.Pos := 0;
    Data.Pattern := @LP;
    LineDDA(FirstPoint.X, FirstPoint.Y, X, Y, @LineDDAProc, LongInt(@Data));
    Drawing := False;
  end
  else
  begin
    FirstPoint := Point(X, Y);
    Drawing := True;
  end;
end;

procedure LineDDAProc(X, Y: Integer; Data: LParam);
begin
  if PDDAData(Data).Pattern[PDDAData(Data).Pos mod SizeOf(TLinePattern)] = 1
  then PDDAData(Data).Canvas.Pixels[X, Y] := PDDAData(Data).Canvas.Pen.Color;
  Inc(PDDAData(Data).Pos);
end;

end.
